<?php
/*********************************************************************************************
+ Top Posters v0.1 : A Plugin for MyBB 1.4 and 1.6
+ Free to Use
+ Free to Edit
+ But Not Allowed to distribute
**********************************************************************************************
*/
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

function ttposters_info()
{
	return array(
		"name"			=> "برترین ارسال کنندگان",
		"description"	=> "نمایش یک لیست از برترین ارسال کنندگان در قسمت آمار، فارسی سازی توسط MyBBIran.com",
		"website"		=> "http://yaldaram.com",
		"author"		=> "Yaldaram",
		"authorsite"	=> "http://yaldaram.com",
		"version"		=> "0.1",
		"compatibility" => "14*,16*",
		"guid" => "ff3c48d5900bbd8427971d3cf1c9d61d"
	);

}
function ttposters_activate()
{
	global $db, $mybb;

	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	$template = array(
		"title"		=> "ttp_index",
		"template"	=> '
<tr>
<td class="tcat">
<strong>{$exact_time}</strong>
</td>
</tr>
<tr>
<td class="trow1">
<span class="smalltext">{$tt_posters}</span></td>
</tr>',
		"sid"		=> -1
	);
	$db->insert_query("templates", $template);

	$template = array(
		"title"		=> "ttp_bit",
		"template"	=> '{$comma}{$user[\\\'avatar\\\']}&nbsp;{$user[\\\'profilelink\\\']}{$postcount}',
		"sid"		=> -1
	);
	$db->insert_query("templates", $template);

find_replace_templatesets("index_boardstats", "#".preg_quote('{$whosonline}')."#i", '{\$whosonline}{\$ttposters}');

	$ttposters_group = array(		"gid"			=> "NULL",		"name"			=> "ttposters",		"title" 		=> "برترین ارسال کنندگان",		"description"	=> "تنظیمات پلاگین",		"disporder"		=> "1",		"isdefault"		=> "no",
	);
	$db->insert_query("settinggroups", $ttposters_group);
	$gid = $db->insert_id();
	$ttposters_setting_1 = array(		"sid"			=> "NULL",		"name"			=> "ttposters_power",		"title"			=> "کلید",		"description"	=> "اگر می خواهید پلاگین نمایش داده شود روی بله انتخاب شود.",		"optionscode"	=> "yesno",		"value"			=> "no",		"disporder"		=> "1",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $ttposters_setting_1);
	$ttposters_setting_2 = array(		"sid"			=> "NULL",		"name"			=> "ttposters_howmany",		"title"			=> "چند کاربر",		"description"	=> "چند کاربر می خواهید در لیست نمایش داده شود؟",		"optionscode"	=> "text",		"value"			=> "25",		"disporder"		=> "2",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $ttposters_setting_2);
	$ttposters_setting_3 = array(		"sid"			=> "NULL",		"name"			=> "ttposters_timeline",		"title"			=> "مدت زمان",		"description"	=> "زمان مورد نظر.",
		"optionscode"	=> "select
3600=1 ساعت
7200=2 ساعت
21600=6 ساعت
43200=12 ساعت
86400=24 ساعت
2592000=1 ماه",
		"value"			=> "86400",		"disporder"		=> "3",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $ttposters_setting_3);
	$ttposters_setting_4 = array(		"sid"			=> "NULL",		"name"			=> "ttposters_whosee",		"title"			=> "چه کسانی می توانند ببینند؟",		"description"	=> "گروه هایی که می توانند لیست را مشاهده کنند وارد کرده و با کاما از هم جدا کنید.",		"optionscode"	=> "text",		"value"			=> "3,4,6,7,8",		"disporder"		=> "4",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $ttposters_setting_4);
	$ttposters_setting_5 = array(		"sid"			=> "NULL",		"name"			=> "ttposters_avatar",		"title"			=> "نمایش آواتار",		"description"	=> "آیا می خواهید آواتار در کنار نام کاربری مشاهده شود؟",		"optionscode"	=> "yesno",		"value"			=> "yes",		"disporder"		=> "5",		"gid"			=> intval($gid),
	);
	$db->insert_query("settings", $ttposters_setting_5);
    rebuild_settings();
}
function ttposters_deactivate()
{
	global $db, $mybb;
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='ttposters'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='ttposters_power'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='ttposters_howmany'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='ttposters_timeline'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='ttposters_whosee'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='ttposters_avatar'");
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("index_boardstats", "#".preg_quote('{$ttposters}')."#i", '', 0);
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='ttp_index'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='ttp_bit'");
    rebuild_settings();
}
$plugins->add_hook("index_start", "ttposters_do");
function ttposters_do(){
	global $db, $mybb, $lang, $ttposters, $templates;
	$power = $mybb->settings['ttposters_power'];
	$time = $mybb->settings['ttposters_timeline'];
	$lang->load("ttposters");
	if ($time == "3600"){
		$exact_time = $lang->tt_one_hour;
	}
	elseif ($time == "7200")
	{
		$exact_time = $lang->tt_two_hours;
	}
	elseif ($time == "21600")
	{
		$exact_time = $lang->tt_six_hours;
	}
	elseif ($time == "43200")
	{
		$exact_time = $lang->tt_twelve_hours;
	}
	elseif ($time == "86400")
	{
		$exact_time = $lang->tt_twentyfour_hours;
	}
	elseif ($time == "2592000")
	{
		$exact_time = $lang->tt_one_month;
	}
	if ($power != "0"){
		$ttposters = '';
		$limit = $mybb->settings['ttposters_howmany'];
		$comma = '';
		$count = 0;
		$dateline = TIME_NOW - $mybb->settings['ttposters_timeline'];
		$query = $db->query("SELECT COUNT(post.dateline) AS postcount, post.uid, user.uid, user.username, user.usergroup, user.displaygroup, user.avatar 
		FROM ".TABLE_PREFIX."posts AS post 
		JOIN ".TABLE_PREFIX."users AS user ON (post.uid=user.uid) 
		WHERE dateline > $dateline 
		GROUP BY post.uid 
		ORDER BY postcount DESC 
		LIMIT $limit");
		
		while($ttp = $db->fetch_array($query)){
			$count++;
			$user['username'] = format_name($ttp['username'], $ttp['usergroup'], $ttp['displaygroup']);
			$user['profilelink'] = build_profile_link($user['username'], $ttp['uid']);
			if ($mybb->settings['ttposters_avatar'] == "1")
			{
				$user['avatar'] = "<img src='".$ttp['avatar']."' width='23' height='23' title='".$ttp['username']."' alt='".$ttp['username']."'>";
			}
			else
			{
				$user['avatar'] = "";
			}
			$postcount = " (".$ttp['postcount'].")";
			eval("\$tt_posters .= \"".$templates->get("ttp_bit")."\";");
			$comma = ", ";
		}
		
		if($count == "0"){
			$tt_posters = $lang->tt_posters_none;
		}
		$group = $mybb->user['usergroup'];
		$groups = explode(",",$mybb->settings['ttposters_whosee']);
		if (in_array($group,$groups)){
			eval("\$ttposters = \"".$templates->get("ttp_index")."\";");
		}
	}
}
?>